/*
 Copyright (C) 2010-2011 by Hoefer Alfred

 Licensed under the LGPL v2.1, see the file COPYING.LIB
*/

#include "appXbase.h"

int XDrawRectangle(Display *dpy, Drawable d, GC gc, int x, int y, dword width, dword height) {
// printf("%s(%d): XDrawRectangle: w=0x%x %d %d %dx%d\n", FL, (int)d, x, y, width, height);
  int isTempDC;
  HDC hDC;

	if (gc->gcv.stipple) {
	    hDC = GetTmpPaintDC(d, &isTempDC, gc, gcdc_hbrush);
	    SetTextColor(hDC, gc->gcv.foreground);
	    SetBkColor(hDC, gc->gcv.background);
/*	    int m = PATCOPY;
	    if (gc->gcv.function == GXandInverted) {
		m = PATINVERT;
	    } else if (gc->gcv.function == GXxor) {
		m = PATINVERT;
	    } */
	    int m = PATINVERT;

	    BitBlt(hDC, x, y, width, 1, 0, 0, 0, m); 
	    BitBlt(hDC, x, y+height, width, 1, 0, 0, 0, m); 
	    BitBlt(hDC, x, y, 1, height, 0, 0, 0, m); 
	    BitBlt(hDC, x+width, y, 1, height, 0, 0, 0, m);

	} else {
	    hDC = GetTmpPaintDC(d, &isTempDC, gc, gcdc_hpen);
	    MoveToEx(hDC, x, y, NULL);
	    LineTo(hDC, x+width, y);
	    LineTo(hDC, x+width, y+height);
	    LineTo(hDC, x, y+height);
	    LineTo(hDC, x, y);
	}
	ReleaseTmpPaintDC(d, hDC, isTempDC);
	return 0;
}
