/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "appXbase.h"

bool GetXWinAbs_rc(XID win, TWRect *rc) {
  TGeometry gm;
	if (!win || (win == appXDat.RootW) || !get_geometry(win, &gm)) return False;
	rc->width = gm.width;
	rc->height = gm.height;
	rc->left = gm.x;
	rc->top = gm.y;
	XTranslateCoordinates(appXDat.dpy, win, appXDat.RootW, 0, 0, &rc->left, &rc->top, &gm.root);
	return True;
}
