/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under the LGPL v2.1, see the file COPYING.LIB
*/

#include "appXbase.h"

#define GrabPointer_Mask0  ButtonPressMask | ButtonReleaseMask | ButtonMotionMask | PointerMotionMask | EnterWindowMask | LeaveWindowMask

void Std_GrabPointer(TWins *gw, Cursor GrabCursor) {
	if (appXDat.GrabWin == gw) return;
	if (appXDat.GrabWin) Std_UngrabPointer();
#ifndef USE_NANO_X
	if (gw) XGrabPointer(appXDat.dpy, gw->WinID, 1, GrabPointer_Mask0, GrabModeAsync, GrabModeAsync, appXDat.RootW, GrabCursor, 0);
#endif /* USE_NANO_X */
	appXDat.GrabWin = gw;
}

void Std_UngrabPointer() {
	if (appXDat.GrabWin) {
#ifndef USE_NANO_X
	    XUngrabPointer(appXDat.dpy, 0);
#endif /* USE_NANO_X */
	    appXDat.GrabWin = NULL;
	    XFlush(appXDat.dpy);
	}
}
