/*
 Copyright (C) 2010 by Hoefer Alfred

 Licensed under the LGPL v2.1, see the file COPYING.LIB
*/

#include "appXbase.h"

bool keysymtostr(KeySym *keysym, char *ret,  bool UTF8on) {
	if ((*keysym >= 0x20) && (*keysym < 0x80)) {
	    *ret = *(char*)keysym;
	    ret++;
	    *ret = 0;

	} else if (!UTF8on && (*keysym >= 0x80) && (*keysym < 0x100)) {
	    *ret = *(char*)keysym;
	    ret++;
	    *ret = 0;

	} else if (UTF8on && (*keysym >= 0x80) && (*keysym < 0xe000)) {
	    WCharsToUtf8(ret, 4, (word*)keysym, 1, False);

	} else return False;

	return True;
}
