/*
 Copyright (C) 2010 by Hoefer Alfred

 Licensed under the LGPL v2.1, see the file COPYING.LIB
*/


#include "image.h"

int get_bytes_per_line(int width, int bytes_per_line, dword format) {
	if (bytes_per_line > 0) return bytes_per_line;
	if (width < 0) return 0;

	format = format & pxmLD_bppMask;

	if (format == pxm_2b_16bpp) {
	    bytes_per_line = ((width + 1) >> 1) * 4;
	} else if (format == pxm_YUV420) {
	} else if (format == pxm_YUV422) {
	    bytes_per_line = ((width + 1) >> 1) * 4;
	} else {
	    bytes_per_line = width * 4;
	}
	return bytes_per_line;
}
