/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

#include "appXbase.h"
#include "image.h"

const ThGetDeskIcon *hGetDeskIcon;



void InitIconPaths(TpcIni *ini) {
	if (hGetDeskIcon && hGetDeskIcon->InitIconPaths)
		hGetDeskIcon->InitIconPaths(ini);
}

TPic *GetDeskIcon(int ddkt, int size, const char *name, int fu, const char *default_zico) {
	if (hGetDeskIcon && hGetDeskIcon->GetDeskIcon) {
	    return hGetDeskIcon->GetDeskIcon(ddkt, size, name, fu, default_zico);
	}
	if (default_zico) return GetZIcon(default_zico);
	return NULL;
}
