
#include "rsz.h"

.globl Set_Resize_head
.globl Chk_Resize_XX_11

Set_Resize_head:
	mov	0x14(%ebp), %esi
	sub	rsz_SIZE, %ebp
	test	$0x04, %ebp
       jz	Resize_head_al8
	sub	$0x04, %ebp
Resize_head_al8:
	mov	%esi, %eax

	mov	rsz_SIZE>>2, %ecx	/* copy rsz head */
	mov	%ebp, %edi
	rep
	movsd
	mov	%eax, Timg_rsz
       ret

Chk_Resize_XX_11:   /* return  ecx=new_w ebx=new_h  edi=kw esi=kh */
	mov	rszERR_LE2x2Pixel, %eax	/* return 1  = ERROR: img kleiner 2x2 bixel */

	movzwl	dest_lg_x, %ecx
	cmp	$0x01, %ecx
       jle	end_a
	movzwl	dest_lg_y, %ebx
	cmp	$0x01, %ebx
       jle	end_a

// kw = (org_w << 16) / new_w;
	movzwl	src_lg_x, %eax
	shl	$0x10, %eax
	xor	%edx, %edx
	divl	%ecx
	mov	%eax, %edi

// kh = (org_h << 16) / new_h;
	movzwl	src_lg_y, %eax
	shl	$0x10, %eax
	xor	%edx, %edx
	divl	%ebx
	mov	%eax, %esi

	mov	rszERR_ZoomGT255, %eax	/* return 2  = ERROR: Zoom > 1:255 */
	cmp	$0xffffff, %esi
       jg	end_a
	cmp	$0xffffff, %edi
       jg	end_a

	xor	%eax, %eax
end_a:
       ret


