/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#define PEN_ART_X11	0
#define PEN_ART_ALD	1
#define PEN_ART_CAIRO	2


#define AlgTPen AlgTTC \
  TImage *img; \
  dword Color; \
  float line_width; \
  float x, y; \
  void (*set_color)(struct TCSelf *self, dword Color); \
  void (*set_line_width)(struct TCSelf *self, float width); \
  void (*move_to)(struct TCSelf *self, float x, float y); \
  void (*line_to)(struct TCSelf *self, float x, float y); \
  void (*rect_point)(struct TCSelf *self, float x, float y); \
  void (*flush)(struct TCSelf *self);


#define TCSelf TPen
typedef struct TPen {
  AlgTPen
} TPen;
#undef TCSelf

extern void TPen_Create(TImage *img, int size, int art);
