/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under the LGPL v2.1, see the file COPYING.LIB
*/

#include "appbase.h"

TEv_Array *Add_appEv(void (*On_appEv)(TEv_Array *appEv)) {
  TEv_Array *pev, **ppev;

	ppev = &appDat.appEv_Array;
	while (*ppev) ppev = &(*ppev)->next;
	pev = xcalloc(sizeof(TEv_Array));
	pev->On_appEv = On_appEv;
	*ppev = pev;
	return pev;
}

void Free_appEv(TEv_Array *appEv) {
	if (appEv) appEv->On_appEv = NULL;
}
