/*
 Copyright (C) 2010-2011 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"

char *ChangeFileName(const char *fn, const char *name) {
  char *tmp = GetFilePath(fn);
  char *res = pcadd(tmp, name);
	xfree(tmp);
	return res;
}

void ChangeFileName_ppc(char **fn, const char *name) {
  char *s;
	if (!fn) return;
	s = ChangeFileName(*fn, name);
	xfree(*fn);
	*fn = s;
}
