/*
 Copyright (C) 2010-2011 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"
#include "sysbaseio.h"
#include <stdarg.h>
#include <unistd.h>

void fd_write_va(int fd, const char *msg, ...) {
  va_list args;
  char line[BUFSIZ];
  int lg;
	if (msg) {
	    va_start(args, msg);
	    vsnprintf(line, sizeof(line), msg, args);
	    va_end(args);
	    lg = pclen(line);
	    if (lg) write(fd, line, lg);
	}
}
