/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"
#include "sysbaseio.h"

bool file_mkdir_ae(const char *fn, int mode, int err_level) {
  TNetErrRet ErrRet;

	net_err_init(&ErrRet);
	if (file_mkdir(fn, &ErrRet, mode)) return True;
	net_err_app_4(&ErrRet, fn, "mkdir", err_level);
	net_err_clr(&ErrRet);
	return False;
}
