/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"
#include "sysbaseio.h"
#include <errno.h>

bool file_read_full(FileHandle fd, TNetErrRet *ErrRet, void *buf, size_t bufsize, size_t *retsize) {
  byte *data = buf;
  size_t retsz = 1;
  size_t lg = 0;

	while (retsz && (bufsize > 0)) {
	    if (!file_read(fd, ErrRet, data, bufsize, &retsz)) return False;
	    data += retsz;
	    lg += retsz;
	    bufsize -= retsz;
	}
	if (retsize) *retsize = lg;
	return True;
}
