/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"
#include "sysbaseio.h"

int gptfu_DisplayFileStr = gptfu_noPasswd|gptfu_noRootArt;

static char *get_DisplayXStr(const char *fn, TglobPath *gp, int gptfu) {
  char *res;
  TglobPath *gpt  = gp;

	if (!gpt) {
	    if (!fn) return NULL;
	    gpt = pctogp(fn);
	}
	res = gptopc(gpt, gptfu);
	if (gpt != gp) gpFree(gpt);
	return res;
}

char REGP2 *get_DisplayFileStr(const char *fn, TglobPath *gp) {
	return get_DisplayXStr(fn, gp, gptfu_DisplayFileStr);
}

char REGP2 *get_DisplayPathStr(const char *fn, TglobPath *gp) {
	return get_DisplayXStr(fn, gp, gptfu_DisplayFileStr|gptfu_noName);
}
