/*
 Copyright (C) 2010-2011 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "net_xxx.h"

void TNet_send_ioinfo(TNet *self) {

	if (!(self->ioinfo.stat & fmIOInfo_EOF) &&
	    (self->ioinfo.Time_us < self->next_us)) return;

	self->fmsg.art = fmArt_DataIO;
	self->fmsg.typD = fmTyp_ioinfo;
	self->fmsg.D.ioinfo = &self->ioinfo;
	self->fmsg.typF = fmTyp_none;

	TNet_msg((TNet*)self);
	self->next_us += self->next_us_add;
}
