/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"

char *path_add_Slash(const char *basepath, const char *s) {
  char *result = path_add(basepath, s); //mem + 2

	if (result) {
	    int lg = pclen(result);
	    if ((lg > 0) && TestNoSlash(result[lg-1])) {
		result[lg] = '/';
		result[lg+1] = 0;
	    }
	} else result = pcdup(S_SLASH);

	return result;
}

void path_add_Slash_ppc(char **basepath, const char *s) {
  char *tmp;
	if (!basepath) return;
	tmp = path_add_Slash(*basepath, s);
	xfree(*basepath);
	*basepath = tmp;
}
