/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#ifdef _OS_WIN32

#include "sysbase.h"

bool path_cmp(const char *a, const char *b) {
  char *x, *y;
  bool result;
	x = pcdup(a);
	y = pcdup(b);
	slash_korr(x, False);
	slash_korr(y, False);
	result = pccasecmp(x, y);
	xfree(y);
	xfree(x);
	return result;
}

#endif
