/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"

long pwclen(const word *s) {
#if defined(__x86_64__)
  long i = 0;
 __asm__ volatile(
	"test	%%rdi,%%rdi \n"
       "jz	9f \n"
	"mov	%%rdi,%%rcx \n"
       "jmp	2f \n"
"1: \n"
	"add	$2,%%rdi \n"
"2: \n"
	"cmpw	(%%rdi),%%ax \n"
       "jnz	1b \n"
"3: \n"
	"sub	%%rcx,%%rdi \n"
	"mov	%%rdi,%%rax \n"
	"shr	$1,%%rax \n"
"9: \n"
		: "+%rax"(i)
		: "r"(s)
		: "%rcx");
	return i;
#else
  long i = 0;
	if (s) while (*s) {i++; s++;}
	return i;
#endif
}

