/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"

/* result False = OK */
bool cmd_get_float(int argc, char **argv, char *pc, int *idx, float *res) {
  int i;
	pc++;
	if (*pc == '=') {
	    pc++;
	    goto endok;

	} else if (((*pc >= '0') && (*pc <= '9')) || (*pc == '-')) {
	    goto endok;
	}

	i = *idx + 1; 
	if ((i < argc) && (*argv[i] != '-')) {
	    *idx = i;
	    pc = argv[i];
	    goto endok;
	}
	return True;
endok:
	*res = pctodouble(pc);
	return False;
}
