/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"
//Achtung *ret min 16 char's

void doubletoppc(char **ppc, double w, int decipoint) {
  double d10; 
  int lg, m, i10;
  char *pc;
  int nk = decipoint & 0x000f;
  int e = 0;

	if (!ppc) return;
	pc = *ppc;
	if (!pc) return;

	if (nk > 9) nk = 9;
	lg = 0;
	if ((w == 0) || (w == (w/2))) {  //test zero or inf
	    *pc++ = '0'; lg++;
	    if (nk > 0) {
		*pc++ = '.'; lg++;
		while (nk) {*pc++ = '0'; lg++; nk--;}
	    }
	} else {
	    if (w < 0) {*pc = '-'; pc++; lg++; w = -w;}
	    d10 = 0.5;
	    m = nk;
	    while (m--) d10 /= 10;
	    w += d10;
	    if (w >= 1) {
		while (w > 1E+10) {e++; w /= 10;}
		d10 = 100;
		while (d10 < w) d10 *= 100;
		while ((d10 >= 1) && (d10 > w)) d10 /= 10;
		while (d10 >= 1) {
		    m = w / d10;
		    *pc++ = (m + 0x30); lg++;
		    w = w - (d10 * m);
		    d10 /= 10;
		}
	    } else {
		*pc++ = '0'; lg++;
	    }
	    if (nk > 0) {
		*pc++ = '.'; lg++;
		while (nk--) {
		    w *= 10;
		    m = w;
		    *pc++ = (m + 0x30); lg++;
		    w = w - m;
		}
	    }
	    if (e) {
		*pc++ = 'E'; lg++;
		*pc++ = '+'; lg++;
		i10 = 100;
		while ((i10 > 0) && (i10 > e)) i10 /= 10;
		while (i10 > 0) {
		    m = e / i10;
		    *pc++ = (m + 0x30); lg++;
		    e = e - (i10 * m);
		    i10 /= 10;
		}
		
	    }
	}
	*ppc = pc;
	ppcmove_kchar(ppc, decipoint);
}

int doubletopc(char *pc, double w, int decipoint) {
  char *pcn = pc;
	doubletoppc(&pcn, w, decipoint);
	return pcn-pc;
}
