/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"

//min_nums +char  0x100000 add ' ' 0x200000 add ',' 0x30000 add ';' 

void hex64toppc(char **ppc, uint64_t val, int min_nums) {
  char *pc = *ppc;
  int min = min_nums & 0x1f;
  int i = 15;

	while (i && (i >= min) && !(val & 0xf000000000000000)) {
	    val <<= 4; i--;
	}
	i++;
	while (i) {
	    int b = (val >> 60) & 0x0f;
	    if (b > 9) b += 7;
	    *pc = b + 0x30; pc++;
	    val <<= 4; i--;
	}
	*ppc = pc;
	ppcmove_kchar(ppc, min_nums);
}

void hex64topc(char *pc, uint64_t val, int min_nums) {
  char *pcn = pc;
	hex64toppc(&pcn, val, min_nums);
}

void hex64to0xppc(char **ppc, uint64_t val, int min_nums) {
  char *pc = *ppc;
	*pc = '0'; pc++;
	*pc = 'x'; pc++;
	*ppc =  pc;
	hex64toppc(ppc, val, min_nums);
}

void hex64to0xpc(char *pc, uint64_t val, int min_nums) {
  char *pcn = pc;
	hex64to0xppc(&pcn, val, min_nums);
}
