/*
 Copyright (C) 2010 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#ifdef _OS_WIN32
.global _Fill0
.global _FillChar0
_Fill0:
_FillChar0:
#else
.globl Fill0
.globl FillChar0
	.type	 Fill0,@function
	.type	 FillChar0,@function
Fill0:
FillChar0:
#endif
	push	%edi
	mov	0x08(%esp),%edi
	mov	0x0c(%esp),%ecx

	xor	%eax,%eax
fill_xc:
	test	%edi,%edi
       je	fill0_end
	test	%ecx,%ecx
       jle	fill0_end
	cmp	$7,%ecx
       jle	fill0_b
	mov	%ecx,%edx
	mov	%edi,%ecx
	and	$0x03,%ecx
       je	fill0_w
	neg	%ecx
	and	$0x03,%ecx
	sub	%ecx,%edx
	rep	stosb
fill0_w:
	mov	%edx,%ecx
	shr	$2,%ecx
//	rep	stosd
	rep	stos %eax,%es:(%edi)
	mov	%edx,%ecx
	and	$0x03,%ecx
fill0_b:
	rep	stosb
fill0_end:
	pop	%edi
       ret

#ifdef _OS_WIN32
.global _FillChar
_FillChar:
#else
.globl FillChar
	.type	 FillChar,@function
FillChar:
#endif
	push	%edi
	mov	0x08(%esp),%edi
	mov	0x0c(%esp),%ecx
	movzbl	0x10(%esp),%eax

	mov	%al,%ah
	mov	%eax,%edx
	shl	$16,%edx
	or	%edx,%eax
       jmp	fill_xc
