/*
 Copyright (C) 2010-2011 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"

int ppcadd_n(char **ppc, int n, ...) {
  va_list args;
  int lg, i, pplg;
  char *pc;

	if (!ppc) return 0;

	lg = 0;
	va_start(args, n);
	for (i=n;i>0;i--) lg += pclen(va_arg(args, char*));
	va_end(args);

	pplg = pclen(*ppc);
	if (!lg) return pplg;
	lg += pplg + 1;
	
	if (pplg) {
	    *ppc = xrealloc(*ppc, lg);
	} else {
	    *ppc = xmalloc(lg);
	}
	pc = *ppc + pplg;

	va_start(args, n);
	for (i=n;i;i--) ppcmove(&pc, va_arg(args, char*));
	va_end(args);
	return lg;
}
