/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"

//void ppclg_Add2_slg(char **ppc, int *pplg, char *a, int alg, char *b, int blg);

void ppclg_ins_slg(char **ppc, int *pplg, const char *s, int slg, int ins_idx) {
  char *pc, *spc;

	if (!ppc || !s) return;
#if 1
  int l1 = *pplg;
	spc = *ppc;
	if (!spc || (ins_idx >= l1)) {
	    ppclg_Add2_slg(ppc, pplg, s, slg, NULL, 0);
	} else if (s && slg) {
	    *pplg = l1 + slg;
	    pc = xmalloc(l1 + slg + 1);
	    *ppc = pc;
	    if (ins_idx < 0) ins_idx = 0;
	    ppcnmove(&pc, spc, ins_idx);
	    ppcnmove(&pc, s, slg);
	    ppcnmove(&pc, spc + ins_idx, l1 - ins_idx);
	    xfree(spc);
	}
#else
	spc = *ppc;
	if (!spc || !*pplg || (ins_idx >= *pplg)) {
	    ppclg_Add2_slg(ppc, pplg, s, slg, NULL, 0);
	} else if (s && slg) {
	    pc = xmalloc(*pplg + slg + 1);
	    *ppc = pc;
	    if (ins_idx < 1) {
		ppcnmove(&pc, s, slg);
		ppcnmove(&pc, spc, *pplg);
	    } else {
		ppcnmove(&pc, spc, ins_idx);
		ppcnmove(&pc, s, slg);
		ppcnmove(&pc, &spc[ins_idx], *pplg - ins_idx);
	    }
	    xfree(spc);
	    *pplg += slg;
	}
#endif
}

void ppcins(char **ppc, const char *s, int ins_idx) {
  int slg = pclen(*ppc);
	ppclg_ins_slg(ppc, &slg, s, pclen(s), ins_idx);
}


