/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"

//************************** Colors *****************************************
word REGP1 RGB24To16(dword Col) {
  //Color    rrrrrrrr gggggggg bbbbbbbb
  //pf16bit          rrrrr gggggg bbbbb
  return ((Col >> 8) & 0xf800) | ((Col >> 5) & 0x7e0) | ((Col >> 3) & 0x1f);
}

dword REGP1 RGB16To24(word RGB16) {
  //pf16bit: rrrrr gggggg bbbbb
  return ((RGB16 & 0x1f) << 3) | ((RGB16 & 0x7e0) << 5) | ((RGB16 & 0xf800) << 8);
}
