/*
 Copyright (C) 2010 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"

void set_arr(void **parr, int headsize, int old_items, int items, int size) {
  int newlg = items * size + headsize;
  char *new = NULL;

// printf("set_arr items=%d old_items=%d newlg=%d\n", items, old_items, newlg);
	if (!*parr) {
	    if (items > 0) new = xcalloc(newlg);

	} else if (items > old_items) {
	    new = xrecalloc(*parr, newlg, old_items * size + headsize);

	} else if (items < old_items) {
	    if (items > 0) {
		new = xrealloc(*parr, newlg);
	    } else {
		xfree(*parr);
	    }

	} else return;
	*parr = new;
}

