/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"

word *UTF8lgstopwc(Tlgs *lgs, int UCfu) {
  int lgw;
  word *pwc;
	if (!lgs || !lgs->lg || !lgs->s) return NULL;
	lgw = Chk_fio_UTF8(lgs->s, lgs->lg, NULL)+1;
	pwc = xmalloc(lgw*2);
	Utf8ToWChars(pwc, lgw, lgs->s, lgs->lg, UCfu);
	return pwc;
}

word *UTF8topwc_fu(const char *pc, int UCfu) {
  int lg, lgw;
  word *pwc;

	lg = pclen(pc);
	if (lg <= 0) return NULL;
	lgw = Chk_fio_UTF8(pc, lg, NULL)+1;
	pwc = xmalloc(lgw*2);
	Utf8ToWChars(pwc, lgw, pc, lg, UCfu);
	return pwc;
}

word *UTF8topwc(const char *pc) {
	return UTF8topwc_fu(pc, 0);
}
