/*
 Copyright (C) 2010 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "appXbase.h"


TcrDat_Row* TGrid_AddRow(TGrid *gr) {
  int y = gr->RowCount;
	TGrid_EditEnd(gr);
	TGrid_SetRowCount(gr, y+1);
	return &gr->RowDat[y];
}

TcrDat_Row* TGrid_InsRow(TGrid *gr, int Idx) {
  int i, y;
  TcrDat_Row *cr, crd;

	TGrid_EditEnd(gr);
	if (Idx < gr->FixedRows) Idx = gr->FixedRows;
	y = gr->RowCount;
	if (Idx >= y) return TGrid_AddRow(gr);
	TGrid_SetRowCount(gr, y+1);
	pnmove(&crd, &gr->RowDat[y], sizeof(TcrDat_Row));
	for (i=y;i>Idx;i--) {
	    pnmove(&gr->RowDat[i], &gr->RowDat[i-1], sizeof(TcrDat_Row));
	}
	cr = &gr->RowDat[Idx];
	pnmove(cr, &crd, sizeof(TcrDat_Row));
	if (gr->ResizeStartMk) TGrid_Chk_VHSB(gr);
	return cr;
}

void TGrid_DelRow(TGrid *gr, int Idx) {
  int y;
  TcrDat_Row crd;

	TGrid_EditEnd(gr);
	if ((Idx < gr->FixedRows) || (gr->RowCount <= gr->FixedRows)) return;
	y = gr->RowCount-1;
	if (Idx < y) {
	    if ((gr->SelectIdxRow == Idx) && gr->DoSelect) gr->DoSelect(gr, grBefFu_DelRow);
	    pnmove(&crd, &gr->RowDat[Idx], sizeof(TcrDat_Row));
	    pnmove(&gr->RowDat[Idx], &gr->RowDat[Idx+1], sizeof(TcrDat_Row)*(y-Idx));
	    pnmove(&gr->RowDat[y], &crd, sizeof(TcrDat_Row));
	}
	TGrid_SetRowCount(gr, y);
}

