/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "appXbase.h"

bool TMenu_DelItemI(TMenu *self, int idx) {
  TMenuItem *mi;
  bool hasNext = False;;

	mi = TMenu_GetItemI(self, idx);
	if (mi) {
	    hasNext = mi->next != NULL;
	    TMenu_DelItem(self, mi);
	}
	return hasNext;
}

TMenuItem *TMenu_PushS(TMenu *self, const char *s, int maxItem) {
  TMenuItem *result = NULL;
	if (s && *s) {
	    TMenu_DelItemS(self, s);
	    result = TMenu_AddItem(self, s, miAddInv, NULL);
	    if (maxItem > 0) while (TMenu_DelItemI(self, maxItem));
	}
	return result;
}
