/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "appXbase.h"

TTreeVNode* TTreeVNode_get_by_name_lg(TTreeVNode *tvn, const char *name, int lg, bool all) {
  int L;
  const char *pc;
	while (tvn) {
	    TTreeVNode_GetCaption_s_lg(tvn, &pc, &L);
#ifdef _OS_WIN32
	    if ((L == lg) && !pcncasecmpASCII(pc, name, lg)) return tvn;
#else
	    if ((L == lg) && pcncmp(pc, name, lg)) return tvn;
#endif
	    if (all) tvn = tvn->next; else tvn = TTreeVNode_get_next(tvn);
	}
	return NULL;
}
