/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

#ifndef __ALDFIND_H__
#define __ALDFIND_H__    1

#include "../mOpenWith.h"
#include "../FormExecWith.h"
#include "../miCopy.h"

#define wtyp_TFormFind (wtyp_USER_Form + 1)


#define TCSelf TFormFind
typedef struct TFormFind {
  AlgTForm
  TWins *pnlTop;
//  TWins *pnlTopL;
  TWins *pnlTop2;

  TMenuButton *mbFile, *mbSetting, *mbHelp;
  TMenu *menuFile, *menuSetting, *menuHelp;
  TMenuItem *miModifiedVis, *miPermissonVis;

  TPageControl *pgc;
  TPage *pgFiles;
   TComboBox *cbName;
   TComboBox *cbPath;
   TButton *buPath;
   TFile_Dlg *File_Dlg;
   TChkBox *cbSubDir;
   TChkBox *cbFileCaseSens;

  TPage *pgData;
   TComboBox *cbFText;
   TChkBox *cbTextCaseSens;
   TChkBox *cbInclBinFile;
   TChkBox *cbOnlyASCII;

  struct TFindGrid *grFind;

  char *SelPath, *SelName;

  TChkBox *cbSelPlusPart;
  TEdit *edSelTxt;
  TButton *buStart;
  TButton *buStop;
  TButton *buClose;

    TMenu *menuEdit;
        TMenuOpenWith *menuOpenWith;
	TMenuItem *miOpenWith;


  void *pthd_find;

  TPattern *patt;
  struct Tcmpx *cmpx;

  char *runPath;
  char *FirstLine;
  int  FirstLineCharType;
  dword ref_ms;
  dword FindCount;
  dword FindCountMax;
  bool Stop;
} TFormFind;
#undef TCSelf

extern const char zico16aldfind[];
extern TFormFind *TFormFind_Create(TWins *Parent, char *workdir);
extern void TFormFind_SetWorkDir(TFormFind *self, char *workdir);
extern bool TFormFind_ChkWorkDirOk(TglobPath *gp);
extern void TFormFind_UpdataUTF8(TFormFind *self);



#endif /* __ALDFILE_H__ */
