/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

#include "aldfile.h"

/* ______________________ OnMenu _____________________________________ */
/*
#define ddi_File 0x01
#define ddi_Net  0x02
#define ddi_Mask 0x03
#define ddi_Multi_File 0x05
#define ddi_Multi_Net  0x06

int mf_ChkItem(TMenuFile *self, TMenuFileItem *mfi) {
  int m;
  char *fn, *indata, *token;
  TpcIni *ini;
  TDesktopHead ddkh;
  int result = 0;

	if (!mfi || !mfi->filename) return False;
	fn = pcadd(self->path, mfi->filename);
	ini = TpcIni_Create(fn);
	xfree(fn);
	if (dotdesktop_get_head(ini, &ddkh) && 
	    (ddkh.ddkt == ddkt_Application)) {

	    indata = (char*)ddkh.exec;
	    if (!indata) indata = (char*)ddkh.tryexec;
	    while (indata) {
		indata = pcGetToken(indata, &token, &m);
		if (*token == '%') {
		    if (token[1] == 'f') {
			result = ddi_File;
		    } else if (token[1] == 'F') {
			result = ddi_Multi_File;
		    } else if (token[1] == 'u') {
			result = ddi_Net;
		    } else if (token[1] == 'U') {
			result = ddi_Multi_Net;
		    }
		}
	    }
	}
	Tfree(ini);
	return result;
}


static void menuTools_OnMenuOpen(TMenuFile *self) {
  int ddi;
  TMenuFileItem *mfi;
  Txdfl xdfl;

	get_MenuFileItem_xdfl(self, &xdfl);
	mfi = (TMenuFileItem*)self->MenuItem;
	while (mfi) {
	    mfi->fu &= ~miNotEnabled;
	    ddi = mf_ChkItem(self, mfi);
	    if (!xdfl.isLocalF && ((ddi & ddi_Mask) != ddi_Net)) mfi->fu |= miNotEnabled;
	    mfi = (TMenuFileItem*)mfi->next;
	}
}

static void menuToolsWith_OnClick(TMenuFile *self, long KeyState, bool DblClick) {
	OpenWith_Click(self, cmd_onlyPath);
}
*/

/* ______________________ Create _____________________________________ */
void MenuTools_Create(TMainForm *self) {
	self->mbTools = TMenuButton_CreateS(self->pnlTop, self->mbFile, "Tools");
//	self->mbTools->Enabled = False;

	self->menuTools = TMenuOpenWith_Create((TWins*)self, NULL);
//	self->menuTools->OnGetDskCmd = OpenWith_OnGetDskCmd;
	self->menuTools->path = pcadd(appDat.ALDini_dir, "/Menu/Tools/");
	self->miTools->next_menu = (TMenu*)self->menuTools;
	self->mbTools->menu = (TMenu*)self->menuTools;

/*
	self->menuTools = TMenuFile_Create((TWins*)self);
	self->miTools->next_menu = (TMenu*)self->menuTools;
	self->mbTools->menu = (TMenu*)self->menuTools;
	self->menuTools->OnMenuOpen = menuTools_OnMenuOpen;
	self->menuTools->path = pcadd(appDat.ALDini_dir, "/Menu/Tools/");
	self->menuTools->OnClick = menuToolsWith_OnClick;
	self->menuTools->mfk = mfk_AutoFree;
*/
}
