/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

#include "aldpic.h"


void ALDpic_mFile_PrintIndex(TMenu *self, long KeyState, TMenuItem *smi) {
#ifndef _OS_WIN32
  TMainForm *fpic = (TMainForm*)self->FormStruct;
  TFileWin *fw = (TFileWin*)fpic->FileWin;
  TDirFileList *dfl = TFileWin_Get_dfl0(fw);
  int count = 0;

	if (!fw->GetFilePic) return;

	while (dfl) {
	    if ((dfl->st->st & st_Reg) &&
		(dfl->st->FileType == stft_IMAGE)) {
 		count++;
		if (!dfl->obj) {
		    fw->GetFilePic(fw, dfl, 32, fwgfp_bef_GetPic);
		    AppHandleMessage();
		}

	    }
	    dfl = dfl->next;
	}

	if (!count) return;

  TPixMap *pxm;
  TPic *pic;
  int x, y, wo, ho, tw, tx;
  const char *s;

	pxm = TPixMap_Create_depth(786, 1112, 0);
//	pxm = TPixMap_Create(466, 540, 0);
//	pxm->RGB_Korr = &RGB_Korr;
//	pxm = TPixMap_Create(772, 1092, 0);
	TPixMap_ClsRGB(pxm, 0xffffff);
	pxm->vds = xcalloc(sizeof(TVDrawString));
	pxm->vds->WinID = pxm->pmxID;
	pxm->vds->Font = appXDat.Default_Font;

//	x = ((772-10)-128*5) / 4; = 30,5
	wo = 158;	//128+30
	ho = 135;
	x = 10;
	y = 10;
	dfl = TFileWin_Get_dfl0(fw);
	count = 0;
//	for (i=0;i<tfl->Count;i++) {
//	    cs = tfl->lines->cs[i];
//	    if (cs && (cs->st->st_AH & stah_Reg) && (cs->st->st_AHFileType == stft_IMAGE)) {
	while (dfl) {
	    if ((dfl->st->st & st_Reg) &&
		(dfl->st->FileType == stft_IMAGE)) {

		pic = fw->GetFilePic(fw, dfl, 32, fwgfp_bef_GetPic);

		DrawPic(pxm->pmxID, pic, x, y);

		s = Get_ExFileDat_pc(dfl->st, exfdt_FileName);
		vds_SetStr(pxm->vds, s);
		tw = TextWidthColorString(pxm->vds);
		tx = x - 15 + ((wo - tw) / 2) ;
  printf("%s(%d): %d %s\n", FL, tx, s);
		DrawColorString(tx, y + 100, pxm->vds);


		x += wo;
		count++;
		if (count > 4) {
//		if (count > 2) {
		    count = 0;
		    x = 10;
		    y += ho;
		}
//	    }
//	}
	    }
	    dfl = dfl->next;
	}
	TPixMap_XGetImage(pxm);
//	TPixMap_Write_PNG("/tmp/AAA.png", pxm, 0);
//	TImage_WR((TImage*)pxm, "/tmp/AAA.png", 0, write_png);
	ppcfree(&pxm->vds->s);
	Tfree(pxm);
#endif /* _OS_WIN32 */
}

