#include "TeCache.h"

#ifdef use_PAGES

void MemMoveK0_ASM(TMemMoveK *mmk) {
 __asm__ volatile(
		"ldr	%%r0, %3 \n"
	      "0:\n"
		"ldr	%%r1, %0 \n"
		"ldr	%%r2, %1 \n"
		"ldr	%%r3, %2 \n"
	      "1:\n"
		"nop \n"
		"nop \n"
		"subs	%%r3, #1 \n"
	      "bcs	1b \n"
		"ldr	%%r1, %0 \n"
		"ldr	%%r2, %1 \n"
		"ldr	%%r3, %2 \n"
	      "2:\n"
		"nop \n"
		"nop \n"
		"subs	%%r3, #1 \n"
	      "bcs	2b \n"
		"subs	%%r0, #1 \n"
	      "bcs	0b \n"
		: :"m"(mmk->pi1),"m"(mmk->pi2),"m"(mmk->size),"m"(mmk->k)
		: "r0","r1","r2","r3","r4"
		);
}

void MemMoveK_ASM(TMemMoveK *mmk) {
 __asm__ volatile(
		"ldr	%%r0, %3 \n"
	      "0:\n"
		"ldr	%%r1, %0 \n"
		"ldr	%%r2, %1 \n"
		"ldr	%%r3, %2 \n"
	      "1:\n"
		"ldr	%%r4, [%%r1, #4]!\n"
		"str	%%r4, [%%r2, #4]!\n"
		"subs	%%r3, #1 \n"
	      "bcs	1b \n"
		"ldr	%%r1, %0 \n"
		"ldr	%%r2, %1 \n"
		"ldr	%%r3, %2 \n"
	      "2:\n"
		"ldr	%%r4, [%%r1, #4]!\n"
		"str	%%r4, [%%r2, #4]!\n"
		"subs	%%r3, #1 \n"
	      "bcs	2b \n"
		"subs	%%r0, #1 \n"
	      "bcs	0b \n"
		: :"m"(mmk->pi1),"m"(mmk->pi2),"m"(mmk->size),"m"(mmk->k)
		: "r0","r1","r2","r3","r4"
		);
/* __asm__ volatile(
		"ldr	%%r0, %3 \n"
	      "0:\n"
		"ldr	%%r1, %0 \n"
		"ldr	%%r2, %1 \n"
		"ldr	%%r3, %2 \n"
	      "1:\n"
		"ldr	%%r4, [%%r1, #4]\n"
		"str	%%r4, [%%r2, #4]\n"
		"sub	%%r3, #1 \n"
	      "bne	1b \n"
		"ldr	%%r1, %0 \n"
		"ldr	%%r2, %1 \n"
		"ldr	%%r3, %2 \n"
	      "2:\n"
		"ldr	%%r4, [%%r1, #4]\n"
		"str	%%r4, [%%r2, #4]\n"
		"sub	%%r3, #1 \n"
	      "bne	2b \n"
		"sub	%%r0, #1 \n"
	      "bne	0b \n"
		: :"m"(mmk->pi1),"m"(mmk->pi2),"m"(mmk->size),"m"(mmk->k)
		: "r0","r1","r2","r3","r4"
		); */
}

#endif
