/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public License
 as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version. 

 This library is distributed in the hope that it will be useful, 
 but WITHOUT ANY WARRANTY; without even the implied warranty of 
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 See the GNU Lesser General Public License for more details. 

 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the Free
 Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,
 MA 02110, USA
*/

#ifndef	__ZSRC_H__
#define	__ZSRC_H__    1

#ifndef __SYSBASE_H__
 #include "sysbase.h"
#endif

#define zsrc_no_comp	0
#define zsrc_zlib_comp	1


typedef struct {
  const char *name;
  const byte *data;
  const dword data_size;
  const dword org_size;
  const int compress;	//zsrc_no_comp, zsrc_zlib_comp
} ThZsrc;

#define ZsrcFu_OnlyNotExists	1

/* result */
#define ZsrcError	-1
#define ZsrcOk		0
#define ZsrcExists	1

int ZsrcToPath(const ThZsrc *zsrc, const char *path, const char *name, int fu);



#endif /* __ZSRC_H__ */
