/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under the LGPL v2.1, see the file COPYING.LIB
*/

#include "appXbase.h"

int XFillRectangle(Display *dpy, Drawable d, GC gc, int x, int y, dword width, dword height) {
  int isTempDC;
  HDC hDC;
  RECT rc;

	if (gc->gcv.function  == GXnand) {
	    hDC = GetTmpPaintDC(d, &isTempDC, gc, gcdc_hbrush);
	    BitBlt(hDC, x, y, width, height, 0, 0, 0, DSTINVERT | PATINVERT); 
	} else {
	    hDC = GetTmpPaintDC(d, &isTempDC, gc, 0);
	    rc.left = x;
	    rc.top = y;
	    rc.right = x+width;
	    rc.bottom = y+height;
	    if (gc->gcv.stipple) {
		SetTextColor(hDC, gc->gcv.background);
	    }
	    FillRect(hDC, &rc, gc->hbrush);
	}
	ReleaseTmpPaintDC(d, hDC, isTempDC);
	return 0;
}
