/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under the LGPL v2.1, see the file COPYING.LIB
*/

#include "appXbase.h"

int XSetClipRectangles (Display * dpy, GC gc, int clip_x_origin, int clip_y_origin,
			XRectangle * rectangles, int n, int ordering) {

	if (gc->gcv.clip_mask) DeleteObject(gc->gcv.clip_mask);
	gc->gcv.clip_mask = CreateRectRgn(rectangles[0].x, rectangles[0].y, 
			rectangles[0].x + rectangles[0].width, 
			rectangles[0].y + rectangles[0].height);
	gc->gcv.clip_x_origin = clip_x_origin;
	gc->gcv.clip_y_origin = clip_y_origin;

	return 1;
}

