/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under the LGPL v2.1, see the file COPYING.LIB
*/

#include "appXbase.h"

void cmdUTF8korr(int *argc, char ***argv) {
  int count;
  char **ppwc, *indata;
  const char *cpc;

	count = 0;
	indata = pwctoUTF8(GetCommandLineW());
	cpc = indata;
	while (cpc) {
	    cpc = GetToken(cpc, NULL);
	    count++;
	}

	if (*argc != count) printf("%s(%d): ERROR: (argc=%d)<>(count=%d)\n", FL, *argc, count);
	*argc = count;
	ppwc = xcalloc(sizeof(void*)*(count+1));
	*argv = ppwc;

	cpc = indata;
	while (cpc) {
	    cpc = GetToken(cpc, ppwc);
	    ppwc++;
	}
	xfree(indata);
}
