/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under the LGPL v2.1, see the file COPYING.LIB
*/

#include "sysbase.h"
#include "sysbaseio.h"

word *get_pcw_filename(const char *fn, int fu) {
  int slg, dlg;
  word *res, *pwc;

	if (!fn) return NULL;
	slg = pclen(fn);
	dlg = Chk_fio_UTF8(fn, slg, NULL) + 1;
	if (fu & add_end_asterisk) dlg++;
	res = xmalloc(dlg * 2);
	Utf8ToWChars(res, dlg, fn, slg, 0);

	pwc = res;
	while (*pwc) {
	    if (*pwc == '/') *pwc = '\\';
	    pwc++;
	}

	if (fu & add_end_asterisk) {
	    *pwc = '*'; pwc++; *pwc = 0;
	} else if ((fu & del_path_end_slash) && (dlg > 1) && 
	    (pwc[-1] == '\\') && (pwc[-2] != ':')) pwc[-1] = 0;

	return res;
}
