/*
 Copyright (C) 2010-2014 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "appXbase.h"

static void setXAttr(TWins *wins, XSetWindowAttributes *XAttr, bool Value) {
	while (wins) {
	    if (wins->RepTimer) ppTfree(&wins->RepTimer);
	    if (wins->next_child) setXAttr(wins->next_child, XAttr, Value);
	    if (wins) {
		if (!Value) {
		    XAttr->cursor = appXDat.XCursors[wins->cursor_nr];
		}
		XChangeWindowAttributes(appXDat.dpy, wins->WinID, 
					CWCursor, XAttr);
	    }
	    wins = wins->next;
	}
}

void appSetCursorWait(TWins *wins, bool Value) {
  XSetWindowAttributes XAttr;

	if (!appXDat.appCursorWait == !Value) return;
	appXDat.appCursorWait = Value;
	if (Value) AppHandleWinMessages();
	if (!wins) wins = appXDat.Wins;
	Fill0(&XAttr, sizeof(XAttr));
	XAttr.cursor = appXDat.XCursors[XC_watch];
	setXAttr(wins, &XAttr, Value);
	if (Value) AppHandleWinMessages();
}
