/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under the LGPL v2.1, see the file COPYING.LIB
*/


#include "appXbase.h"

#ifdef DRAG_AND_DROP

/* *** ACHTUNG auf Reienfolge achten *** */
static const char *AH_dndAtomsTab[] = {
  "_MOTIF_DRAG_AND_DROP_MESSAGE",
  "_MOTIF_DRAG_INITIATOR_INFO",
  "_MOTIF_DRAG_RECEIVER_INFO",
  "_MOTIF_DRAG_WINDOW",
  "_MOTIF_DRAG_TARGETS",
  "XmTRANSFER_SUCCESS",
  "XmTRANSFER_FAILURE",
  "XdndActionAsk",
  "XdndActionCopy",
  "XdndActionLink",
  "XdndActionMove",
  "XdndActionList",
  "XdndActionPrivate",
  "XdndAware",
  "XdndEnter",
  "XdndPosition",
  "XdndLeave",
  "XdndStatus",
  "XdndSelection",
  "XdndTypeList",
  "XdndProxy",
  "XdndDrop",
  "XdndFinished",
  NULL
};

//    char my_dnd_selection_name[30];  // 11-digit number should be enough
//    sprintf(my_dnd_selection_name, "_MY_DND_SELECTION_%d", (int)getpid());
//    qt_x11_intern_atom( my_dnd_selection_name, &Dnd_selection );

Tdnd *Tdnd_Atoms_Create() {
  Tdnd *dnd = appXDat.dnd;
  int i;
  Atom *a;

	if (dnd) return dnd;
	dnd = xcalloc(sizeof(Tdnd));
	appXDat.dnd = dnd;

	a = &dnd->XA_MOTIF_DRAG_AND_DROP_MESSAGE;
	i = 0;
	while (AH_dndAtomsTab[i]) {
	    *a = XInternAtom(appXDat.dpy, AH_dndAtomsTab[i], 0);
	    a++; i++;
	};
//	sprintf(my_dnd_selection_name, "_MY_DND_SELECTION_%d", (int)getpid());
//	XInternAtom(appXDat.dpy, my_dnd_selection_name, 0);
//	sprintf(my_dnd_selection_name, "WM_S%d", (int)getpid());
//	XInternAtom(appXDat.dpy, my_dnd_selection_name, 0);

	return dnd;
}

#endif  /* DRAG_AND_DROP */

