/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under the LGPL v2.1, see the file COPYING.LIB
*/

#include "appXbase.h"

int GetMouseX_CharPos(int x, TVDrawString *vds) {
  int i, m, x0, x1, lg, Result;
  int SpaceW, isp;
  char *s;

	if (!vds) return 0;

	Result = 0;
	x0 = 0;
	x1 = 0;
	lg = vds->lg;
	s =  vds->s;
	vds->lg = 1;
	vds->s_const  = " ";
	SpaceW = TextWidthColorString(vds);
	if (SpaceW < 3) SpaceW = 3;
	vds->lg = lg;
	vds->s = s;
	isp = (x - vds->Xoff) / SpaceW;
	if (isp > lg) isp = lg;

	m = 0;
	if (vds->UTF8on) {
	    i = 0;
	    while (i <= lg) {
		m = i;
		x1 = GetChar_XPos(i, vds);
		if (x1 >= x) break;
		x0 = x1;
		IncUtf8Idx_lgs(&i, (Tlgs*)vds);
		if (i == m) break;
	    }
	    if (m > 0) {
		x1 = x1 - ((x1-x0) >> 1);
		if (x1 >= x) DecUtf8Idx(&m, vds->s);
		Result = m;
	    }
	} else {
	    x1 = GetChar_XPos(isp, vds);
	    while ((x1 > x) && (isp > 15)) {
		isp = (isp * 9) / 10;
		x1 = GetChar_XPos(isp, vds);
	    }
	    if (x1 > x) isp = 0;

	    for (i=isp; i <= lg; i++) {
		m = i;
		x1 = GetChar_XPos(i, vds);
		if (x1 >= x) break;
		x0 = x1;
	    }
	    if (m > 0) {
		x1 = x1 - ((x1-x0) >> 1);
		if (x1 >= x) m--;
		Result = m;
	    }
	}
	return Result;
}
