/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "appXbase.h"

static const word nl_tab[56] = {
  0xFF88,0xFF89,0xFF8A,0xFF8B, 0xFF8C,0xFF0D,0xFF8E,0xFF8F,

  0xFF90,0xFF91,0xFF92,0xFF93, 0xFF94,0xFF50,0xFF51,0xFF52,
  0xFF53,0xFF54,0xFF55,0xFF56, 0xFF57,0xFF9D,0xFF63,0xFFFF,

  0xFFA0,0xFFA1,0xFFA2,0xFFA3, 0xFFA4,0xFFA5,0xFFA6,0xFFA7,
  0xFFA8,0xFFA9,0x002A,0x002B, 0x002C,0x002D,0xFFAE,0x002F,

  0x0030,0x0031,0x0032,0x0033, 0x0034,0x0035,0x0036,0x0037,
  0x0038,0x0039,0xFFBA,0xFFBB, 0xFFBC,0xFFBD,0xFFBE,0xFFBF
};

static const word dead_tab[18] = {
  0x0060,0x00b4,0x005e,0x007e, 0x00af,0xFE55,0xFE56,0x00a8,
  0xFE58,0xFE59,0xFE5A,0x00b8, 0xFE5C,0xFE5D,0xFE5E,0xFE5F,
  0xFE60,0xFE61
};

void REGP1 NumLook_korr(TKeyEvent *KeyEv) {
  int ks = KeyEv->keysym;
	if ((ks >= 0xFE50) && (ks <= 0xFE62)) {
	    KeyEv->keysym = dead_tab[ks - 0xFE50];
	} else if ((ks >= 0xFF88) && (ks <= 0xFFBF)) {
	    KeyEv->keysym = nl_tab[ks - 0xFF88];
	}
}
