/*
 Copyright (C) 2010-2011 by Hoefer Alfred

 Licensed under the LGPL v2.1, see the file COPYING.LIB
*/

#include "appXbase.h"
#include "tpixmap.h"

/*____________________________________________________________________________*/
TPixMap *TPixMap_dup_new_size(TPixMap *org_pxm, int new_width, int new_height) {
  TImage *nimg;
	TPixMap_XGetImage(org_pxm);
	nimg = TImage_dup_new_size((TImage*)org_pxm, new_width, new_height);
	if (alpha_akt(nimg)) alpha2bitmask(nimg);
	return (TPixMap*)nimg;
}

void TPixMap_resize(TPixMap **ppxm, int new_width, int new_height) {
  TPixMap *pxm = TPixMap_dup_new_size(*ppxm, new_width, new_height);
	if (pxm) {
	    Tfree(*ppxm);
	    *ppxm = pxm;
	}
}
