/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "appbase.h"

TpcIni *get_globalIni() {
  TpcIni *pcIni;

	pcIni = appDat.globalIni;
	if (!pcIni) pcIni = TpcIni_Create(appDat.inifile_global);
	return pcIni;
}

void free_globalIni(TpcIni *pcIni) {
	if (appDat.globalIni != pcIni) Tfree(pcIni);
}
