/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "appbase.h"

void REGP1 fd_set_count(int fd) {
  int k;

	if ((fd > FD_SETSIZE) || (fd < 0)) {
	    appError(EMSG_ERR_EXIT, "%s(%d): fd=%d (Max=%d)", FL, fd, FD_SETSIZE);
	}

	k = ((fd >> 5)+1) * 32;
	if (k > appDat.fd_set_count) {
	    appDat.fd_list = xrecalloc(appDat.fd_list, sizeof(Tfd_list) * k, 
				       sizeof(Tfd_list) * appDat.fd_set_count);
	    appDat.fd_set_count = k;
	}

}
