/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"
#include "sysbaseio.h"

bool file_read_ae(FileHandle fd, void *buf, size_t bufsize, size_t *retsize, 
			const char *fn, int err_level) {
  TNetErrRet ErrRet;

	net_err_init(&ErrRet);
	if (file_read(fd, &ErrRet, buf, bufsize, retsize)) return True;
	net_err_app_4(&ErrRet, fn, "read", err_level);
	net_err_clr(&ErrRet);
	return False;
}
