/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"

const char *GetFileName_pc(const char *fn) {
  const char *pc, *pce;

	if (!fn) return NULL;
	pce = fn;
	pc = fn;
	while (*pc) {
	    if (TestSlash(*pc)) pce = pc+1;
	    pc++;
	}
	return pce;
}

char *GetFileName(const char *fn) {
	return pcdup(GetFileName_pc(fn));
}
