/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include <dirent.h>

#ifdef _OS_WIN32
typedef struct {
  HANDLE dh; \
  WIN32_FIND_DATAW fid; \
} T_OS_dh;
#else
typedef struct {
  DIR *dh; \
} T_OS_dh;
#endif

#define Alg_dirlist_nypv  int schr;	/* b0=scan b8=open */ \
  dword open_us; \
  T_OS_dh OS; \
  TglobPath gp; \
  bool change_akt; \
  bool nc1; \
  bool nc2; \
  bool nc3; \
  TDirFileList *tmpdfl;

cHIDDEN void nypv_ChkFile(TDirListNotify *self);
cHIDDEN bool nypv_OpenDir(TDirListNotify *self);
cHIDDEN bool nypv_ScanDir(TDirListNotify *self);

/* tdirlist_ny_misc.c */
cHIDDEN dword REGP2 chk_new_stat_type(Tstat64 *org, Tstat64 *new);
cHIDDEN void REGP2 dl_copy_new_stat_type(Tstat64 *org, Tstat64 *new);


cHIDDEN void REGP2 stat_test_copy_uid_gid(Tstat64 *org, Tstat64 *new);
cHIDDEN dword REGP3 TDirListNotify_chk_dlf_Change(TDirListNotify *self, TDirFileList *dfl, TglobPath *gp);
cHIDDEN void REGP3 TDirListNotify_DodllEv(TDirListNotify *self, TDirFileList **dfl, int bef);
cHIDDEN TDirFileList REGP2 **get_ppdfl(TDirFileList **ppdfl, TDirFileList *dfl);
cHIDDEN TDirFileList REGP2 *TDirListNotify_Del(TDirListNotify *self, TDirFileList *dfl);

cHIDDEN TDirFileList REGP2 *TDirListNotify_Add_st(TDirListNotify *self, Tstat64 *stat);
cHIDDEN TDirFileList REGP2 *TDirListNotify_Add(TDirListNotify *self, TglobPath *gp);

cHIDDEN void REGP1 TDirListNotify_SyncEv(TDirListNotify *self);
cHIDDEN void REGP1 TDirListNotify_ScanEnd(TDirListNotify *self);

cHIDDEN dword REGP2 chk_new_stat(Tstat64 *org, Tstat64 *new);
cHIDDEN void REGP2 dl_copy_new_stat(Tstat64 *org, Tstat64 *new);
