/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"
#include "sysbaseio.h"

char *gptofnpc(TglobPath *gp, int fu, const char *fn) {
  char *result;
	result = gptopc(gp, fu);
	if (fn) {
	    if (fu & gptfu_add_slash) {
		path_add_Slash_ppc(&result, fn);
	    } else {
		path_add_ppc(&result, fn);
	    }
#ifdef _OS_WIN32
	    slash_korr(result, ((gp->fu & gpi_Local) != 0) || (gp->fu & gpi_RA_SMB));
#endif /* ! _OS_WIN32 */
	}
	return result;
}
