/*
 Copyright (C) 2010-2011 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"
#include "sysbaseio.h"

void TpcIni_DelGruppeDat(TpcIni *ti, const char *Gruppe) {
  TGruppe *Gp;
  TGruppeDat *Gpd, *xGpd;

	ti->lastGpD = NULL;
	Gp = TpcIni_FindGruppe(ti, Gruppe);
	if (!Gp) return;
	Gpd = Gp->Dat;
	if (!Gpd) return;
	while (Gpd) {
	    if (Gpd->org) xfree(Gpd->org);
	    xGpd = Gpd;
	    Gpd = Gpd->next;
	    xfree(xGpd);
	}
	Gp->Dat = NULL;
}
