/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"

bool pcfind(const char *s, const char *find, int *idx) {
  int i, lg;
  const char *pc;
	lg = pclen(find);
	if (!s || !*s || !lg) return False;
	pc = s;
	i = pclen(pc) - lg;
	if (i < 0) return False;
	for (;i>=0;i--) {
	    if (pcncmp(pc, find, lg)) {
		if (idx) *idx = pc - s;
		return True;
	    }
	    pc++;
	}
	return False;
}
