/*
 Copyright (C) 2010-2011 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"

int ppcchange_add_n(char **ppc, int n, ...) {
  va_list args;
  int lg, i;
  char *result, *pc;

	if (!ppc) return 0;

	lg = 0;
	va_start(args, n);
	for (i=n;i>0;i--) lg += pclen(va_arg(args, char*));
	va_end(args);

	result = NULL;
	if (lg) {
	    pc = result = xmalloc(lg+1);
	    va_start(args, n);
	    for (i=n;i;i--) ppcmove(&pc, va_arg(args, char*));
	    va_end(args);
	}
	ppcfree(ppc);
	*ppc = result;
	return lg;
}
