/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"


void set_timeval(struct timeval *tv, dword us) {
	if (us < 1000000) {
	    tv->tv_sec = 0;
	    tv->tv_usec = us;
	} else {
	    tv->tv_sec = us / 1000000;
	    tv->tv_usec = us - (tv->tv_sec * 1000000);
	}
}
