/*
 Copyright (C) 2010-2011 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"
#include "sysbaseio.h"

bool TLines_FindS(TLines *tls, const char *s) {
  int lg, slg;
  char *pc;

	if (tls->FindYa < 0) tls->FindYa = 0;
	lg = pclen(s);
	if (tls->FindBack) {
	    while (tls->FindYa >= 0) {
		tls->FindYa--;
	    }
	} else {
	    while (tls->FindYa < tls->Count) {
		pc = tls->lines->cs[tls->FindYa]->s;
		slg = tls->lines->cs[tls->FindYa]->lg - tls->FindXa;
		if (pc && (slg > 0)) {
		    pc += tls->FindXa;

		    if (tls->FindNoCase) {
			while (slg) {
			    if (pcncmp(pc, s, lg)) {
				tls->FindXe = tls->FindXa + lg;
				tls->FindYe = tls->FindYa;
				return True;
			    }
			    pc++;
			    slg--;
			    tls->FindXa++;
			}
		    } else {
			while (slg) {
			    if (pcncasecmp(pc, s, lg)) {
				tls->FindXe = tls->FindXa + lg;
				tls->FindYe = tls->FindYa;
				return True;
			    }
			    pc++;
			    slg--;
			    tls->FindXa++;
			}
		    }
		}
		tls->FindXa = 0;
		tls->FindYa++;
	    }
	}
	return False;
}

