/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "appXbase.h"

/*_____________________________ Create __________________________________*/
TWins *TWins_CreateLabelA(TWins *Parent, int Left, int Top, int Width, int Height, const char *s, int CaptionFu, int BorderFu, int Align) {
  TWins *self;
	self = TWins_Create(Parent);
	self->CaptionFu = CaptionFu | mCaptionPaint;
	if (CaptionFu & (mCaptionLeft | mCaptionRigth)) self->CaptionOffX = 1;
	self->BorderFu = BorderFu;
	self->Align = Align;
	SelfCreateS((TWins*)self, Left, Top, Width, Height, s);
	return self;
}

TWins *TWins_CreateLabel(TWins *Parent, int Left, int Top, int Width, int Height, const char *s, int CaptionFu, int BorderFu) {
	return TWins_CreateLabelA(Parent, Left, Top, Width, Height, s, CaptionFu, BorderFu, 0);
}
