/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "appXbase.h"
#include "filemsg.h"
#include "dlg.h"

void default_Global_OnFileMsg(TFileMsg *fmsg) {

	if (fmsg->art == fmArt_errLogin) {
	    fmsg->res = msgCANCEL;
	    if (fmsg->typD == fmTyp_char) {
#ifndef _OS_WIN32
		XBell(appXDat.dpy, 0);
#endif
		MsgBox_Show_Error(appDat.obj, NULL, msgOK, msgOK, EMSG_ERR | EMSG_H_LF | EMSG_tIO, fmsg->D.s);
	    }
	    if ((fmsg->typR == fmTyp_gp) && Login_Dlg_Create_Execute(appDat.obj, fmsg->R.gp)) {
		fmsg->res = msgOK;
	    }
	    fmsg->Ok = True;
	    fmsg->ev_Stop = True;

	} else if (fmsg->art == fmArt_AlgErr) {
	    if (fmsg->typD == fmTyp_char) {
#ifndef _OS_WIN32
		XBell(appXDat.dpy, 0);
#endif
		MsgBox_Show_Error(appDat.obj, NULL, msgOK, msgOK, EMSG_ERR | EMSG_H_LF | EMSG_tIO, fmsg->D.s);
		fmsg->Ok = True;
		fmsg->ev_Stop = True;
	    }
	}
}

