#include "tlineedit.h"

typedef struct {
  unsigned char *s;
  int lg;
  unsigned char *next;
  int mk;
  char c;
} Tstoken;

typedef struct {
  Thighlight *hl;
  TColS *cs;
  int mk;
  Tstoken *t;
} Thldat;

cHIDDEN void Thighlight_Destroy(Thighlight **phl);
cHIDDEN Thighlight *Thighlight_Create(TWins *wins, TLines *tls);

cHIDDEN void add_scd(TColS *cs, char *pc, int lg, ThlFCol *fc, int fu);
cHIDDEN void add_scd_str_fc(Thldat *hid, Tstoken *t, int mk, char cc, ThlFCol *fc);
cHIDDEN void add_scd_str(Thldat *hid, Tstoken *t);
cHIDDEN void add_scd_nr(Thldat *hld, char *pc, int lg);
cHIDDEN void add_scd_comment(Thldat *hld, char *pc, int lg);

cHIDDEN bool hl_keyword_c0(Thldat *hld, Thl_keyw_arr *karr);
cHIDDEN bool hl_keyword_scan(byte *s, int lg, Thl_keyw_arr *karr);
cHIDDEN bool hl_keyword_scan_case(byte *s, int lg, Thl_keyw_arr *karr);
/* scd_str_len fu */
#define scd_Only_cc 1
#define scd_SkipBlank (1<<1)
#define scd_Num_cc (1<<2)
cHIDDEN int scd_str_len(byte *pc0, byte cc, int fu);

cHIDDEN void add_scd_char(Thldat *hld, char *pc, int lg);   /* in highl_c.c */
cHIDDEN void add_scd_def(Thldat *hid, Tstoken *t);          /* in highl_c.c */
