/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

#include "aldedit.h"
#include "cicons.h"

static void mHelp_Info(TMenu *self, long KeyState, TMenuItem *smi) {
  TFormEdit *fed = (TFormEdit*)self->FormStruct;
  char buf[80];

	fed->Help_Info_Run = true;
	snprintf(buf, sizeof(buf), "ALDedit %s   (build-%d  %s)", 
			VERSION, build_v, build_date);
	Copyright_MsgBox_Show((TWins*)fed, buf);
	fed->Help_Info_Run = false;
}

static void mHelp_cmd(TMenu *self, long KeyState, TMenuItem *smi) {
  TFormEdit *fed = (TFormEdit*)self->FormStruct;
  char *pc = xmalloc(pclen(Help_Msg)+60);

	fed->Help_cmd_Run = true;
	sprintf(pc, Help_Msg, build_v, build_date);
	MsgBox_Show((TWins*)fed, "ALDedit cmd", pc, msgOK | msgFontFixed, 0);
	xfree(pc);
	fed->Help_cmd_Run = false;
}

/* ______________________ Create _____________________________________ */
void MenuHelp_Create(TFormEdit *fed) {
  TMenuItem *mi;

	fed->mbHelp = TMenuButton_Create(fed->PanelTop, fed->mbFile);
	SetCaption((TWins*)fed->mbHelp, "Help");
	Set_Parent((TWins*)fed->mbHelp, fed->PanelTop);

	fed->menuHelp = TMenu_Create((TWins*)fed);
	fed->mbHelp->menu = fed->menuHelp;

	mi = TMenu_AddItem(fed->menuHelp, "Info", 0, mHelp_Info);
	mi->pic = get_pic16_info(False);
	mi = TMenu_AddItem(fed->menuHelp, "cmd", 0, mHelp_cmd);
	mi->pic = get_pic16_shell(False);
}
