/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

#ifndef __MENUOPENWITH_H__
#define __MENUOPENWITH_H__    1

/* ------------------- mOpenWith.c ------------------------------------------ */
#define MOWfu_ChDir     1
#define MOWfu_QnlyLocal (1<<1)
#define MOWfu_OnlyDir   (1<<2)

#define TCSelf TMenuOpenWith
#define TCMenuItem TMenuFileItem
typedef struct TMenuOpenWith {
  AlgTMenuFile
  bool (*OnGetDskCmd)(struct TCSelf *self, TDesktopCMD *dskcmd, int fu);
} TMenuOpenWith;
#undef TCMenuItem
#undef TCSelf

typedef bool (*TOnGetDskCmd)(void *obj, TDesktopCMD *dskcmd, int fu);

extern TMenuOpenWith *TMenuOpenWith_Create(TWins *parent);

extern void OpenWith_Exec(const char *path, const char *filename, void *obj, 
			  TOnGetDskCmd OnGetDskCmd);

#endif /* __ALDFILE_H__ */
