/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

#include "ElMath.h"
#include "dlg.h"
#include "cicons.h"

static void mHelp_Info(TMenu *self, long KeyState, TMenuItem *smi) {
  TFormElMath *fmain = (TFormElMath*)self->FormStruct;
  char buf[80];
	snprintf(buf, sizeof(buf), "%s %s   (build-%d  %s)", 
				APPNAME, VERSION, build_v, build_date);
	Copyright_MsgBox_Show((TWins*)fmain, buf);
}

/* ______________________ Create _____________________________________ */
void MenuHelp_Create(TFormElMath *fmain) {
  TMenuItem *mi;

	fmain->mbHelp = TMenuButton_Create(fmain->pnlTop, fmain->mbFile);
	SetCaption((TWins*)fmain->mbHelp, "Help");
	Set_Parent((TWins*)fmain->mbHelp, fmain->pnlTop);

	fmain->menuHelp = TMenu_Create((TWins*)fmain);
	fmain->mbHelp->menu = fmain->menuHelp;

	mi = TMenu_AddItem(fmain->menuHelp, "Info", 0, mHelp_Info);
	mi->pic = get_pic16_info(False);
}
