/*
 Copyright (C) 2010-2011 by Hoefer Alfred

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either
 version 2 of the License, or (at your option) any later version. 

 This program is distributed in the hope that it will be useful, 
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 See the GNU General Public License for more details. 

 You should have received a copy of the GNU General Public
 License along with this program; if not, write to the Free
 Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,
 MA 02110, USA

 ----------------------------------------------------------------
 Licensed under GPL v2, see file COPYING in this tarball
*/

#include "buildin_et.h"

const int build_v = ALD_BUILD_V;
const char *build_date = __DATE__;

int main (int argc, char **argv) {
	cmdline_slash_korr(argc, argv);

  TBuildin_app *bi_app;
	bi_app = Get_Buildin_pc(argv[0]);
	if (bi_app) return bi_app(argc, argv);
	if ((argc > 1) && (*argv[1] != '-')) {
		cmdline_del_argv0(&argc, argv);
		bi_app = Get_Buildin_pc(argv[0]);
		if (bi_app) return bi_app(argc, argv);
		BuildinHelp();
		return EXIT_FAILURE;
	}
	BuildinHelp();
	return EXIT_FAILURE;
}
